// ̧قDoxygenpɏĂ܂B
/*! \file *********************************************************************
*
* Atmel Corporation
*
* - ̧		: motor.h
* - ߲		: IAR EWAVR 4.11a
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATtiny13
*
* - pLq	: AVR440 - 2׼ڽDCӰ̊mȂ
*
* - 		: (\)S萔̧قɊ܂܂܂B
*
* $Revision: 1.4 $
* $Date: Thursday, September 29, 2005 13:53:48 UTC $
******************************************************************************/

#ifndef __MOTOR_H__
#define __MOTOR_H__

/*! \brief  ۯg
 *
 * Hzł̼ ۯgłB̒l̒l̐mȐݒɈˑ܂B
 */
#define SYS_FREQ				9600000UL

/*! \brief 1ms̸ۯ
 *
 * 1ms̸ۯBӰnٰ݂ŎԎ菇Ɏgp܂B
 */
#define MILLISEC_NUM_CYCLES		(SYS_FREQ / 1000U)

/*! \brief ŏ̑㎥̈̂߂̉]qɑ΂ҋ@
 *
 * ͍ŏ̑㎥̈̂߂̉]qɑ΂đҋ@msPʂł̎ԂłB
 * ̒l͈ႤӰ̎ނɑ΂ĈقȂ܂B
 */
#define ROTOR_STABILIZATION_TIME_MS		1800U

#define ROTOR_LOCK_RAMPUP_DELAY_MS		5U				//! nŒ蒆ޭè ّԒx(msP)
#define ROTOR_LOCK_RAMPDOWN_DELAY_MS	1U				//! nŒޭè ٌԒx(msP)

/*! \brief 1vɉۯ
 *
 * ̒l1vԂɓn(2/ꊄ荞݊Ԃ)ۯLq܂B
 * ʑł/0255ւ0֌vAĈ܂B
 */
#define TICK_NUM_CYCLES			(510UL)

/*! \brief @BI1]̐(])
 *
 * @BI1]̐(])񐔂łB
 */
#define COMMUTATIONS_PER_REV	4UL

/*! \brief ŏeOCRl
 *
 * OCR0A/BɏŏlłB͍ŏޭè ق߂܂(ޭè 
 * =OCR0A/Bl255)B
 */
#define MIN_OCR_VALUE			0x01

/*! \brief ő勖eOCRl
 *
 * OCR0A/BɏőlłB͍őޭè ق߂܂(ޭè 
 * =OCR0A/Bl255)B$FF(255)ő100%ޭè قƓłB
 */
#define MAX_OCR_VALUE			0xff

/*! \brief Ӱ̍ő]x
 *
 * ̒lӰ̍ő]xw肵܂B
 */
#define MAX_RPM					2800UL

/*! \brief Ӱ̍ŏ]x
 *
 * ̒l͓삷ׂӰ̍ŏxw肵܂BӰ͂̑xɉĊm
 * (])œłȂ΂Ȃ܂BӰႢxłmȂ
 * (])œł悤ɁAŜ߂̗]TuƂ܂B
 */
#define MIN_RPM					550UL

/*! \brief mȂ(])Mɑ铮҂łŒᑬx
 *
 * ̒l͊mȂ(])Mɑ铮҂łŒᑬxw肵
 * B̉pł͑x̌Eȉ̏ꍇޭè ق100%ɑ₳܂B
 */
#define CRITICALLY_LOW_RPM		500UL

/*! \brief x(RPM)vɕϊϸ
 *
 * ϸۂ͕̋@BIȉ]ŗ^鑬x(RPM)̑xɉ鐮
 * (])Ԃ̌vɕϊ܂B
 *
 *  \param RPM ̋@BIȉ]ŗ^鑬x
 *
 *  \return ̑xɉ鐮(])Ԃ̌v
 */
#define RPM2COMM_TICKS(RPM)		(unsigned int)(SYS_FREQ / ((RPM * TICK_NUM_CYCLES * COMMUTATIONS_PER_REV) / 60))

#define MAX_RPM_TICKS			(RPM2COMM_TICKS(MAX_RPM))	// ōɑΉv((])Ԑ)
#define MIN_RPM_TICKS			(RPM2COMM_TICKS(MIN_RPM))	// ŒᑬɑΉv((])Ԑ)

#define CRITICALLY_LOW_RPM_TICKS	(RPM2COMM_TICKS(CRITICALLY_LOW_RPM))	// 댯ȒᑬɑΉv((])Ԑ)

/*! \brief 1ڑ
 *
 * ͑1ڑ݂`܂Bꂪʂ݂ɐڑ
 * A̒lPWM_PHASE1̗ύXȂ΂Ȃ炸A̗ύXĂ
 * B
 */
#define WINDING1_PIN			PB0

/*! \brief 2ڑ
 *
 * ͑2ڑ݂`܂Bꂪʂ݂ɐڑ
 * A̒lPWM_PHASE2̗ύXȂ΂Ȃ炸A̗ύXĂ
 * B
 */
#define WINDING2_PIN			PB1

/*! \brief 1㎥pTCCR0Aݒl
 *
 * ̒l͑1㎥̎TCCR0ȂSew肵܂B͊1(WINDING1_
 * PIN)PB0ƈقȂ݂ɐڑꍇɂύXׂłB
 */
#define PWM_PHASE1				((1 << COM0A1) | (0 << COM0A0) | (0 << COM0B1) | (0 << COM0B0) | (0<<WGM01) | (1<<WGM00))

/*! \brief 2㎥pTCCR0Aݒl
 *
 * ̒l͑2㎥̎TCCR0ȂSew肵܂B͊2(WINDING1_
 * PIN)PB1ƈقȂ݂ɐڑꍇɂύXׂłB
 */
#define PWM_PHASE2				((0 << COM0A1) | (0 << COM0A0) | (1 << COM0B1) | (0 << COM0B0) | (0<<WGM01) | (1<<WGM00))

/*! \brief S㎥ȂTCCR0Aݒl
 *
 * ̒l͊S㎥ȂTCCR0Aڼ޽̊Sȓew肵܂B
 */
#define PWM_OFF					((0 << COM0A1) | (0 << COM0A0) | (0 << COM0B1) | (0 << COM0B0) | (0<<WGM01) | (1<<WGM00))

/*! \brief 1̑pADMUXݒl
 *
 * ̒l͑1̓dǂނ߂ADMUXڼ޽̑Sew肵܂B
 */
#define ADC_PHASE1				((1 << REFS0) | (1 << ADLAR) | (1 << MUX1) | (0 << MUX0))

/*! \brief 2̑pADMUXݒl
 *
 * ̒l͑2̓dǂނ߂ADMUXڼ޽̑Sew肵܂B
 */
#define ADC_PHASE2				((1 << REFS0) | (1 << ADLAR) | (1 << MUX1) | (1 << MUX0))

/*! \brief ȎxpADMUXݒl
 *
 * ̒l͊Oxǂݍ݂ɑ΂ADMUXڼ޽̊Sȓew肵܂B
 */
#define ADC_SPEED_REF			((1 << REFS0) | (1 << ADLAR) | (0 << MUX1) | (1 << MUX0))

#define ADC_PRESCALER			((0 << ADPS2) | (1 << ADPS1) | (1 << ADPS0))		// A/DϊۯOuݒ(=8)

#define PHASE1					0	//! 1ԕϐ
#define PHASE2					1	//! 2ԕϐ

/*! \brief 0oOɐ(])̈ҋ@v
 *
 * ̒lA/Dϊl0oɎgpOɁA(])̈ҋ@
 * ߂̌vw肵܂B
 */
#define ADC_WAIT_TICKS			50

/*! \brief 0oɎgp臒l̋NdA/Dϊl
 *
 * ̒l0oɎgpNd͂臒lA/Dϊlw肵܂B̒l
 * ߂͐(])̐mȏuԂύX܂BʓIɂ荂臒l葁
 * (])ɋA܂B
 */
#define ADC_THRESHOLD			0x78

/*! \brief ]x()Mo͑I׸
 *
 * ̕`ꂽꍇA(Œ`)TACHO_OUT_PINɉ]x()M
 * ܂B
 */
//#define TACHO_ENABLED

#ifdef TACHO_ENABLED
/*! \brief ]x()Mo
 *
 * ̒l(ꂽꍇ)]x()Mǂ݂ɏo͂̂w肵
 * B]x()o(PB5)݂gpꍇAOؾĂ֎~邱Ƃ
 * YȂłB
 */
#define TACHO_OUT_PIN			PB5
#endif

/*! \brief 1ޭè ِݒϸ
 *
 * ϸۂ͑1ޭè قݒ肵܂B
 *
 *  \param duty OCR0Aݒl
 */
#define SET_DUTY_PHASE1(duty)	(OCR0A = (duty))

/*! \brief 2ޭè ِݒϸ
 *
 * ϸۂ͑2ޭè قݒ肵܂B
 *
 *  \param duty OCR0Bݒl
 */
#define SET_DUTY_PHASE2(duty)	(OCR0B = (duty))

/*! \brief 1,2ޭè ِݒϸ
 *
 * ϸۂ͑1,2ޭè قݒ肵܂B
 *
 *  \param duty OCR0A/Bݒl
 */
#define SET_DUTY_BOTH_PHASES(duty)		(OCR0A = OCR0B = (duty))

// ֐^錾
static void CheckResetSource(void);
static void InitPORTB(void);
static void InitPWM(void);
static void InitUART(void);
static void InitADC(void);
static void WDTOff(void);
static void InitWDT(void);
static void WaitMillisecs(unsigned int milliSeconds);
static void StartMotor(void);
static unsigned char CalculateDutyCycle(unsigned char duty);

#endif
